=== debian/changelog ===
foonathan-memory (0.7.4-3) unstable; urgency=medium

  * Bump CMake policy version in autopkgtest

 -- Timo Röhling <roehling@debian.org>  Thu, 25 Sep 2025 18:30:12 +0200

foonathan-memory (0.7.4-2) unstable; urgency=medium

  * Upload to unstable.

 -- Timo Röhling <roehling@debian.org>  Mon, 22 Sep 2025 12:00:36 +0200

foonathan-memory (0.7.4-1) experimental; urgency=medium

  * Migrate debian/watch to version 5 format
  * New upstream version 0.7.4
  * Refresh patches (no functional changes)
  * Wrap and sort Debian package files
  * Bump Standards-Version to 4.7.2
  * Bump SONAME to 0.7.4

 -- Timo Röhling <roehling@debian.org>  Tue, 09 Sep 2025 09:28:54 +0200
