=== debian/control ===
Source: foonathan-memory
Section: libs
Priority: optional
Maintainer: Debian Robotics Team <team+robotics@tracker.debian.org>
Uploaders:
 Timo Röhling <roehling@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 dpkg-dev (>= 1.22.5),
 cmake,
 doctest-dev <!nocheck>,
 doxygen <!nodoc>,
Standards-Version: 4.7.2
Homepage: https://github.com/foonathan/memory
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/robotics-team/foonathan-memory.git
Vcs-Browser: https://salsa.debian.org/robotics-team/foonathan-memory

Package: libfoonathan-memory0.7.4
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: STL compatible C++ memory allocator library
 The default STL allocator model has various flaws, for example you cannot
 easily share a single allocator for multiple types. This library is one of
 many proposed solutions for the shortcomings of the standard allocator, which
 unlike many other solutions does not require changes in the STL itself.

Package: libfoonathan-memory-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libfoonathan-memory0.7.4 (= ${binary:Version}),
 ${misc:Depends},
Description: STL compatible C++ memory allocator library - development headers
 The default STL allocator model has various flaws, for example you cannot
 easily share a single allocator for multiple types. This library is one of
 many proposed solutions for the shortcomings of the standard allocator, which
 unlike many other solutions does not require changes in the STL itself.
 .
 This package provides the development headers.

Package: libfoonathan-memory-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: STL compatible C++ memory allocator library - documentation
 The default STL allocator model has various flaws, for example you cannot
 easily share a single allocator for multiple types. This library is one of
 many proposed solutions for the shortcomings of the standard allocator, which
 unlike many other solutions does not require changes in the STL itself.
 .
 This package provides the API documentation.
