=== debian/tests/control ===
Tests:
 build-and-run-test-suite,
Depends:
 cmake,
 doctest-dev,
 g++,
 libfoonathan-memory-dev,
Restrictions:
 allow-stderr,
