=== debian/watch ===
Version: 5

Template: Github
Owner: foonathan
Project: memory
Uversion-Mangle: s/-/./
Matching-Pattern: https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/v@ANY_VERSION@
Filename-Mangle: s%(?:.*?/)?v?@ANY_VERSION@%@PACKAGE@-$1.tar.gz%
